import { getEndpointPlugin } from "@smithy/middleware-endpoint";
import { getSerdePlugin } from "@smithy/middleware-serde";
import { Command as $Command } from "@smithy/smithy-client";
import { commonParams } from "../endpoint/EndpointParameters";
import { de_CreateReplicationConfigCommand, se_CreateReplicationConfigCommand } from "../protocols/Aws_json1_1";
export { $Command };
export class CreateReplicationConfigCommand extends $Command
    .classBuilder()
    .ep(commonParams)
    .m(function (Command, cs, config, o) {
    return [
        getSerdePlugin(config, this.serialize, this.deserialize),
        getEndpointPlugin(config, Command.getEndpointParameterInstructions()),
    ];
})
    .s("AmazonDMSv20160101", "CreateReplicationConfig", {})
    .n("DatabaseMigrationServiceClient", "CreateReplicationConfigCommand")
    .f(void 0, void 0)
    .ser(se_CreateReplicationConfigCommand)
    .de(de_CreateReplicationConfigCommand)
    .build() {
}
