import { getEndpointPlugin } from "@smithy/middleware-endpoint";
import { getSerdePlugin } from "@smithy/middleware-serde";
import { Command as $Command } from "@smithy/smithy-client";
import { commonParams } from "../endpoint/EndpointParameters";
import { de_DeleteReplicationConfigCommand, se_DeleteReplicationConfigCommand } from "../protocols/Aws_json1_1";
export { $Command };
export class DeleteReplicationConfigCommand extends $Command
    .classBuilder()
    .ep(commonParams)
    .m(function (Command, cs, config, o) {
    return [
        getSerdePlugin(config, this.serialize, this.deserialize),
        getEndpointPlugin(config, Command.getEndpointParameterInstructions()),
    ];
})
    .s("AmazonDMSv20160101", "DeleteReplicationConfig", {})
    .n("DatabaseMigrationServiceClient", "DeleteReplicationConfigCommand")
    .f(void 0, void 0)
    .ser(se_DeleteReplicationConfigCommand)
    .de(de_DeleteReplicationConfigCommand)
    .build() {
}
